Index: /branches/HTM-15.1-dev0-NICT/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- /branches/HTM-15.1-dev0-NICT/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1348)
+++ /branches/HTM-15.1-dev0-NICT/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1349)
@@ -59,6 +59,6 @@
   m_iLog2Precision   = LOG2_DISP_PREC_LUT;
   m_uiBitDepthForLUT = 8; // fixed
-  m_receivedIdc = NULL; 
-  m_vps         = NULL; 
+  m_receivedIdc = NULL;
+  m_vps         = NULL;
 }
 
@@ -75,5 +75,6 @@
   xDeleteArray( m_adBaseViewShiftLUT, MAX_NUM_LAYERS, MAX_NUM_LAYERS, 2 );
   xDeleteArray( m_aiBaseViewShiftLUT, MAX_NUM_LAYERS, MAX_NUM_LAYERS, 2 );
-  xDeleteArray( m_receivedIdc, m_vps->getNumViews() );
+  if (m_receivedIdc != nullptr) // NICT FIX
+    xDeleteArray( m_receivedIdc, m_vps->getNumViews() );
 }
 
@@ -84,37 +85,37 @@
   assert( !isInitialized() ); // Only one initialization currently supported
   m_bInitialized            = true;
-  m_vps                     = vps; 
-  m_bCamParsVaryOverTime    = false;   
-  m_lastPoc                 = -1;   
-  m_firstReceivedPoc        = -2; 
+  m_vps                     = vps;
+  m_bCamParsVaryOverTime    = false;
+  m_lastPoc                 = -1;
+  m_firstReceivedPoc        = -2;
 
   for (Int i = 0; i <= vps->getMaxLayersMinus1(); i++)
   {
-    Int curViewIdxInVps = m_vps->getVoiInVps( m_vps->getViewIndex( m_vps->getLayerIdInNuh( i ) ) ) ; 
-    m_bCamParsVaryOverTime = m_bCamParsVaryOverTime || vps->getCpInSliceSegmentHeaderFlag( curViewIdxInVps );    
-  }
-
-  assert( m_receivedIdc == NULL ); 
-  m_receivedIdc = new Int*[ m_vps->getNumViews() ]; 
+    Int curViewIdxInVps = m_vps->getVoiInVps( m_vps->getViewIndex( m_vps->getLayerIdInNuh( i ) ) ) ;
+    m_bCamParsVaryOverTime = m_bCamParsVaryOverTime || vps->getCpInSliceSegmentHeaderFlag( curViewIdxInVps );
+  }
+
+  assert( m_receivedIdc == NULL );
+  m_receivedIdc = new Int*[ m_vps->getNumViews() ];
   for (Int i = 0; i < m_vps->getNumViews(); i++)
   {
-    m_receivedIdc[i] = new Int[ m_vps->getNumViews() ]; 
-  }
-
-  xResetReceivedIdc( true ); 
+    m_receivedIdc[i] = new Int[ m_vps->getNumViews() ];
+  }
+
+  xResetReceivedIdc( true );
 
   for (Int voiInVps = 0; voiInVps < m_vps->getNumViews(); voiInVps++ )
   {
-    if( !m_vps->getCpInSliceSegmentHeaderFlag( voiInVps ) ) 
+    if( !m_vps->getCpInSliceSegmentHeaderFlag( voiInVps ) )
     {
       for (Int baseVoiInVps = 0; baseVoiInVps < m_vps->getNumViews(); baseVoiInVps++ )
-      { 
+      {
         if( m_vps->getCpPresentFlag( voiInVps, baseVoiInVps ) )
         {
-          m_receivedIdc   [ baseVoiInVps ][ voiInVps ] = -1; 
+          m_receivedIdc   [ baseVoiInVps ][ voiInVps ] = -1;
           m_aaiCodedScale [ baseVoiInVps ][ voiInVps ] = m_vps->getCodedScale    (voiInVps) [ baseVoiInVps ];
           m_aaiCodedOffset[ baseVoiInVps ][ voiInVps ] = m_vps->getCodedOffset   (voiInVps) [ baseVoiInVps ];
 
-          m_receivedIdc   [ voiInVps ][ baseVoiInVps ] = -1; 
+          m_receivedIdc   [ voiInVps ][ baseVoiInVps ] = -1;
           m_aaiCodedScale [ voiInVps ][ baseVoiInVps ] = m_vps->getInvCodedScale (voiInVps) [ baseVoiInVps ];
           m_aaiCodedOffset[ voiInVps ][ baseVoiInVps ] = m_vps->getInvCodedOffset(voiInVps) [ baseVoiInVps ];
@@ -131,11 +132,11 @@
 {
   for (Int i = 0; i < m_vps->getNumViews(); i++)
-  {  
+  {
     for (Int j = 0; j < m_vps->getNumViews(); j++)
     {
       if ( overWriteFlag ||  ( m_receivedIdc[i][j] != -1 ) )
       {
-        m_receivedIdc[i][j] = 0; 
-      }      
+        m_receivedIdc[i][j] = 0;
+      }
     }
   }
@@ -171,5 +172,5 @@
 }
 
-Void 
+Void
   CamParsCollector::xInitLUTs( UInt uiSourceView, UInt uiTargetView, Int iScale, Int iOffset, Double****& radLUT, Int****& raiLUT)
 {
@@ -234,11 +235,11 @@
   if( m_firstReceivedPoc == -2 )
   {
-    m_firstReceivedPoc = curPoc; 
-  }
-
-  Bool newPocFlag = ( m_lastPoc != curPoc );  
+    m_firstReceivedPoc = curPoc;
+  }
+
+  Bool newPocFlag = ( m_lastPoc != curPoc );
 
   if ( newPocFlag )
-  {    
+  {
     if( m_lastPoc != -1 )
     {
@@ -246,23 +247,23 @@
     }
 
-    xResetReceivedIdc( false ); 
+    xResetReceivedIdc( false );
     m_lastPoc = pcSlice->getPOC();
   }
 
-  UInt voiInVps          = m_vps->getVoiInVps(pcSlice->getViewIndex());  
+  UInt voiInVps          = m_vps->getVoiInVps(pcSlice->getViewIndex());
   if( m_vps->getCpInSliceSegmentHeaderFlag( voiInVps ) ) // check consistency of slice parameters here
-  {   
+  {
     for( Int baseVoiInVps = 0; baseVoiInVps < m_vps->getNumViews(); baseVoiInVps++ )
-    {        
+    {
       if ( m_vps->getCpPresentFlag( voiInVps, baseVoiInVps ) )
       {
         if ( m_receivedIdc[ voiInVps ][ baseVoiInVps ] != 0 )
-        {      
+        {
           AOF( m_aaiCodedScale [ voiInVps ][ baseVoiInVps ] == pcSlice->getInvCodedScale () [ baseVoiInVps ] );
           AOF( m_aaiCodedOffset[ voiInVps ][ baseVoiInVps ] == pcSlice->getInvCodedOffset() [ baseVoiInVps ] );
         }
         else
-        {          
-          m_receivedIdc   [ voiInVps ][ baseVoiInVps ]  = 1; 
+        {
+          m_receivedIdc   [ voiInVps ][ baseVoiInVps ]  = 1;
           m_aaiCodedScale [ voiInVps ][ baseVoiInVps ]  = pcSlice->getInvCodedScale () [ baseVoiInVps ];
           m_aaiCodedOffset[ voiInVps ][ baseVoiInVps ]  = pcSlice->getInvCodedOffset() [ baseVoiInVps ];
@@ -270,11 +271,11 @@
         }
         if ( m_receivedIdc[ baseVoiInVps ][ voiInVps ] != 0 )
-        {      
+        {
           AOF( m_aaiCodedScale [ baseVoiInVps ][ voiInVps ] == pcSlice->getCodedScale    () [ baseVoiInVps ] );
           AOF( m_aaiCodedOffset[ baseVoiInVps ][ voiInVps ] == pcSlice->getCodedOffset   () [ baseVoiInVps ] );
         }
         else
-        {        
-          m_receivedIdc   [ baseVoiInVps ][ voiInVps ]  = 1; 
+        {
+          m_receivedIdc   [ baseVoiInVps ][ voiInVps ]  = 1;
           m_aaiCodedScale [ baseVoiInVps ][ voiInVps ]  = pcSlice->getCodedScale    () [ baseVoiInVps ];
           m_aaiCodedOffset[ baseVoiInVps ][ voiInVps ]  = pcSlice->getCodedOffset   () [ baseVoiInVps ];
@@ -283,5 +284,5 @@
       }
     }
-  }  
+  }
 }
 
@@ -295,5 +296,5 @@
       fprintf( m_pCodedScaleOffsetFile, "#ViewOrderIdx     ViewIdVal\n" );
       fprintf( m_pCodedScaleOffsetFile, "#------------ -------------\n" );
-      
+
       for( UInt voiInVps = 0; voiInVps < m_vps->getNumViews(); voiInVps++ )
       {
@@ -315,10 +316,10 @@
           {
             if ( m_receivedIdc[baseVoiInVps][voiInVps] != 0 )
-            {            
+            {
               fprintf( m_pCodedScaleOffsetFile, "%12d %12d %12d %12d %12d %12d %12d\n",
-                iS, iE, m_vps->getViewOIdxList( voiInVps ), m_vps->getViewOIdxList( baseVoiInVps ), 
-                m_aaiCodedScale [ baseVoiInVps ][ voiInVps ], 
+                iS, iE, m_vps->getViewOIdxList( voiInVps ), m_vps->getViewOIdxList( baseVoiInVps ),
+                m_aaiCodedScale [ baseVoiInVps ][ voiInVps ],
                 m_aaiCodedOffset[ baseVoiInVps ][ voiInVps ], m_vps->getCpPrecision() );
-            }            
+            }
           }
         }
@@ -334,5 +335,5 @@
 #if !NH_MV
   , m_associatedIRAPType(NAL_UNIT_INVALID)
-  , m_pocCRA(0)  
+  , m_pocCRA(0)
   , m_pocRandomAccess(MAX_INT)
   , m_cListPic()
@@ -426,5 +427,5 @@
     fclose( g_hTrace );
   }
-#endif  
+#endif
 #endif
   while (!m_prefixSEINALUs.empty())
@@ -465,5 +466,5 @@
 #endif
 #if NH_MV
-  m_cCavlcDecoder.setDecTop( this ); 
+  m_cCavlcDecoder.setDecTop( this );
 #endif
   m_cGopDecoder.init( &m_cEntropyDecoder, &m_cSbacDecoder, &m_cBinCABAC, &m_cCavlcDecoder, &m_cSliceDecoder, &m_cLoopFilter, &m_cSAO);
@@ -653,6 +654,6 @@
 #if NH_MV
     const TComVPS* vps = m_parameterSetManager.getVPS(sps->getVPSId());
-    assert (vps != 0); 
-    // TBD: check the condition on m_firstPicInLayerDecodedFlag 
+    assert (vps != 0);
+    // TBD: check the condition on m_firstPicInLayerDecodedFlag
     if (!m_parameterSetManager.activatePPS(m_apcSlicePilot->getPPSId(),m_apcSlicePilot->isIRAP() || !m_firstPicInLayerDecodedFlag[m_layerId] , m_layerId ) )
 #else
@@ -671,19 +672,19 @@
       {
         //, it is a requirement of bitstream conformance that the value of update_rep_format_flag shall be equal to 0.
-        assert( sps->getUpdateRepFormatFlag() == false ); 
-      }
-      sps->checkRpsMaxNumPics( vps, getLayerId() ); 
-
-      // It is a requirement of bitstream conformance that, when the SPS is referred to by 
-      // any current picture that belongs to an independent non-base layer, the value of 
+        assert( sps->getUpdateRepFormatFlag() == false );
+      }
+      sps->checkRpsMaxNumPics( vps, getLayerId() );
+
+      // It is a requirement of bitstream conformance that, when the SPS is referred to by
+      // any current picture that belongs to an independent non-base layer, the value of
       // MultiLayerExtSpsFlag derived from the SPS shall be equal to 0.
 
       if ( m_layerId > 0 && vps->getNumRefLayers( m_layerId ) == 0 )
-      {  
-        assert( sps->getMultiLayerExtSpsFlag() == 0 ); 
+      {
+        assert( sps->getMultiLayerExtSpsFlag() == 0 );
       }
     }
 #if NH_MV_SEI
-    m_seiReader.setLayerId ( newPic->getLayerId      ( ) ); 
+    m_seiReader.setLayerId ( newPic->getLayerId      ( ) );
     m_seiReader.setDecOrder( newPic->getDecodingOrder( ) );
 #endif
@@ -711,5 +712,5 @@
     m_apcSlicePilot->applyReferencePictureSet(m_cListPic, m_apcSlicePilot->getRPS());
 #else
-    m_pcPic = newPic; 
+    m_pcPic = newPic;
 #endif
 
@@ -727,7 +728,7 @@
 #if NH_MV
     pSlice->setPic( m_pcPic );
-    vps=pSlice->getVPS();  
+    vps=pSlice->getVPS();
     // The nuh_layer_id value of the NAL unit containing the PPS that is activated for a layer layerA with nuh_layer_id equal to nuhLayerIdA shall be equal to 0, or nuhLayerIdA, or the nuh_layer_id of a direct or indirect reference layer of layerA.
-    assert( pps->getLayerId() == m_layerId || pps->getLayerId( ) == 0 || vps->getDependencyFlag( m_layerId, pps->getLayerId() ) );   
+    assert( pps->getLayerId() == m_layerId || pps->getLayerId( ) == 0 || vps->getDependencyFlag( m_layerId, pps->getLayerId() ) );
     // The nuh_layer_id value of the NAL unit containing the SPS that is activated for a layer layerA with nuh_layer_id equal to nuhLayerIdA shall be equal to 0, or nuhLayerIdA, or the nuh_layer_id of a direct or indirect reference layer of layerA.
     assert( sps->getLayerId() == m_layerId || sps->getLayerId( ) == 0 || vps->getDependencyFlag( m_layerId, sps->getLayerId() ) );
@@ -779,6 +780,6 @@
   {
 #if NH_MV
-    assert( m_pcPic != NULL ); 
-    assert( newPic  == NULL ); 
+    assert( m_pcPic != NULL );
+    assert( newPic  == NULL );
 #endif
     // make the slice-pilot a real slice, and set up the slice-pilot for the next slice
@@ -863,12 +864,12 @@
   m_cEntropyDecoder.setBitstream      (&(nalu.getBitstream()));
 
-  assert( nalu.m_nuhLayerId == m_layerId );   
+  assert( nalu.m_nuhLayerId == m_layerId );
   m_apcSlicePilot->initSlice(); // the slice pilot is an object to prepare for a new slice
   // it is not associated with picture, sps or pps structures.
-  m_apcSlicePilot->setLayerId( nalu.m_nuhLayerId ); 
-  m_cEntropyDecoder.decodeFirstSliceSegmentInPicFlag( m_apcSlicePilot );   
+  m_apcSlicePilot->setLayerId( nalu.m_nuhLayerId );
+  m_cEntropyDecoder.decodeFirstSliceSegmentInPicFlag( m_apcSlicePilot );
   if ( m_apcSlicePilot->getFirstSliceSegementInPicFlag() )
   {
-#endif  
+#endif
     m_uiSliceIdx = 0;
   }
@@ -916,5 +917,5 @@
   if (m_apcSlicePilot->getRapPicFlag())
   {
-      if ((m_apcSlicePilot->getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP && m_apcSlicePilot->getNalUnitType() <= NAL_UNIT_CODED_SLICE_IDR_N_LP) || 
+      if ((m_apcSlicePilot->getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP && m_apcSlicePilot->getNalUnitType() <= NAL_UNIT_CODED_SLICE_IDR_N_LP) ||
         (m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA && m_bFirstSliceInSequence) ||
         (m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA && m_apcSlicePilot->getHandleCraAsBlaFlag()))
@@ -932,5 +933,5 @@
     else
     {
-      m_apcSlicePilot->setNoOutputPriorPicsFlag(false); 
+      m_apcSlicePilot->setNoOutputPriorPicsFlag(false);
     }
 
@@ -958,5 +959,5 @@
     }
   }
-  
+
   if (m_apcSlicePilot->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA && m_craNoRaslOutputFlag) //Reset POC MSB when CRA has NoRaslOutputFlag equal to 1
   {
@@ -1052,11 +1053,11 @@
   {
     //Check Multiview Main profile constraint in G.11.1.1
-    //  When ViewOrderIdx[ i ] derived according to any active VPS is equal to 1 
-    //  for the layer with nuh_layer_id equal to i in subBitstream, 
-    //  inter_view_mv_vert_constraint_flag shall be equal to 1 
+    //  When ViewOrderIdx[ i ] derived according to any active VPS is equal to 1
+    //  for the layer with nuh_layer_id equal to i in subBitstream,
+    //  inter_view_mv_vert_constraint_flag shall be equal to 1
     //  in the sps_multilayer_extension( ) syntax structure in each active SPS for that layer.
     if( pcSlice->getSPS()->getPTL()->getGeneralPTL()->getProfileIdc()==Profile::MULTIVIEWMAIN
       &&
-      pcSlice->getVPS()->getViewOrderIdx(pcSlice->getVPS()->getLayerIdInNuh(getLayerId()))==1 
+      pcSlice->getVPS()->getViewOrderIdx(pcSlice->getVPS()->getLayerIdInNuh(getLayerId()))==1
       )
     {
@@ -1069,8 +1070,8 @@
     m_pcPic->setViewIndex( getViewIndex() );
     m_pcPic->setIsDepth  ( getIsDepth  () );
-    pcSlice->setIvPicLists( m_dpb );         
-#endif
-#endif
-    
+    pcSlice->setIvPicLists( m_dpb );
+#endif
+#endif
+
     // When decoding the slice header, the stored start and end addresses were actually RS addresses, not TS addresses.
     // Now, having set up the maps, convert them to the correct form.
@@ -1105,5 +1106,5 @@
         else
         {
-          assert( false ); 
+          assert( false );
         }
       }
@@ -1112,7 +1113,7 @@
 #endif
 #if NH_3D_ARP
-      pcSlice->setPocsInCurrRPSs(); 
+      pcSlice->setPocsInCurrRPSs();
       pcSlice->setARPStepNum(m_dpb);
-#endif     
+#endif
 #endif
 
@@ -1199,5 +1200,5 @@
     if ( decProcAnnexI() )
     {
-      pcSlice->checkInCompPredRefLayers(); 
+      pcSlice->checkInCompPredRefLayers();
     }
 #endif
@@ -1238,5 +1239,5 @@
   TComSPS* sps = new TComSPS();
 #if NH_MV
-  sps->setLayerId( getLayerId() ); 
+  sps->setLayerId( getLayerId() );
 #endif
 #if O0043_BEST_EFFORT_DECODING
@@ -1254,5 +1255,5 @@
   TComPPS* pps = new TComPPS();
 #if NH_MV
-  pps->setLayerId( getLayerId() ); 
+  pps->setLayerId( getLayerId() );
 #endif
 #if NH_3D_DLT
@@ -1344,6 +1345,6 @@
     case NAL_UNIT_CODED_SLICE_RASL_R:
 #if NH_MV
-      assert( false ); 
-      return 1; 
+      assert( false );
+      return 1;
 #else
       return xDecodeSlice(nalu, iSkipFrame, iPOCLastDisplay);
@@ -1518,5 +1519,5 @@
 {
   //Output of this process is PicOrderCntVal, the picture order count of the current picture.
-  //  Picture order counts are used to identify pictures, for deriving motion parameters in merge mode and 
+  //  Picture order counts are used to identify pictures, for deriving motion parameters in merge mode and
   //  motion vector prediction and for decoder conformance checking (see clause F.13.5).
 
@@ -1525,35 +1526,35 @@
   TComSlice* slice = m_apcSlicePilot;
   const Int nuhLayerId   = slice->getLayerId();
-  const TComVPS*   vps   = slice->getVPS(); 
-  const TComSPS*   sps   = slice->getSPS(); 
-
-  Int pocDecrementedInDpbFlag = m_pocDecrementedInDpbFlag[ nuhLayerId ]; 
+  const TComVPS*   vps   = slice->getVPS();
+  const TComSPS*   sps   = slice->getSPS();
+
+  Int pocDecrementedInDpbFlag = m_pocDecrementedInDpbFlag[ nuhLayerId ];
 
   if ( isFstPicOfAllLayOfPocResetPer )
   {
-    //  When the current picture is the first picture among all layers of a POC resetting period, 
+    //  When the current picture is the first picture among all layers of a POC resetting period,
     //  the variable PocDecrementedInDPBFlag[ i ] is set equal to 0 for each value of i in the range of 0 to 62, inclusive.
-    pocDecrementedInDpbFlag = false; 
+    pocDecrementedInDpbFlag = false;
   }
 
   //  The variable pocResettingFlag is derived as follows:
-  Bool pocResettingFlag; 
+  Bool pocResettingFlag;
   if ( isPocResettingPicture )
   {
-    //-  If the current picture is a POC resetting picture, the following applies:    
+    //-  If the current picture is a POC resetting picture, the following applies:
     if( vps->getVpsPocLsbAlignedFlag()  )
     {
       //  -  If vps_poc_lsb_aligned_flag is equal to 0, pocResettingFlag is set equal to 1.
-      pocResettingFlag = true; 
+      pocResettingFlag = true;
     }
     else if ( pocDecrementedInDpbFlag )
     {
       //  -  Otherwise, if PocDecrementedInDPBFlag[ nuh_layer_id ] is equal to 1, pocResettingFlag is set equal to 0.
-      pocResettingFlag = false; 
+      pocResettingFlag = false;
     }
     else
     {
       //  -  Otherwise, pocResettingFlag is set equal to 1.
-      pocResettingFlag = true; 
+      pocResettingFlag = true;
     }
   }
@@ -1561,9 +1562,9 @@
   {
     //  -  Otherwise, pocResettingFlag is set equal to 0.
-    pocResettingFlag = false; 
-  }
-
-  Int picOrderCntMsb; 
-  Int picOrderCntVal; 
+    pocResettingFlag = false;
+  }
+
+  Int picOrderCntMsb;
+  Int picOrderCntVal;
 
   //  Depending on pocResettingFlag, the following applies:
@@ -1573,14 +1574,14 @@
     if( slice->getPocResetIdc()  ==  1 )
     {
-      picOrderCntVal = slice->getSlicePicOrderCntLsb(); 
-    }
-    else if (slice->getPocResetIdc()  ==  2 ) 
-    {
-      picOrderCntVal = 0; 
+      picOrderCntVal = slice->getSlicePicOrderCntLsb();
+    }
+    else if (slice->getPocResetIdc()  ==  2 )
+    {
+      picOrderCntVal = 0;
     }
     else
     {
-      picOrderCntMsb = xGetCurrMsb( slice->getSlicePicOrderCntLsb(), slice->getFullPocResetFlag() ? 0 : slice->getPocLsbVal(), 0, sps->getMaxPicOrderCntLsb() ); 
-      picOrderCntVal = picOrderCntMsb + slice->getSlicePicOrderCntLsb(); 
+      picOrderCntMsb = xGetCurrMsb( slice->getSlicePicOrderCntLsb(), slice->getFullPocResetFlag() ? 0 : slice->getPocLsbVal(), 0, sps->getMaxPicOrderCntLsb() );
+      picOrderCntVal = picOrderCntMsb + slice->getSlicePicOrderCntLsb();
     }
   }
@@ -1592,5 +1593,5 @@
     if( slice->getPocMsbCycleValPresentFlag() )
     {
-      picOrderCntMsb = slice->getPocMsbCycleVal() * sps->getMaxPicOrderCntLsb(); 
+      picOrderCntMsb = slice->getPocMsbCycleVal() * sps->getMaxPicOrderCntLsb();
     }
     else if( !firstPicInLayerDecodedFlag  ||
@@ -1598,13 +1599,13 @@
     {
       picOrderCntMsb = 0; //     (F 62)
-    }    
+    }
     else
     {
       Int prevPicOrderCntLsb = m_prevPicOrderCnt & ( sps->getMaxPicOrderCntLsb() - 1 );
-      Int prevPicOrderCntMsb = m_prevPicOrderCnt - prevPicOrderCntLsb; 
-      picOrderCntMsb = xGetCurrMsb( slice->getSlicePicOrderCntLsb(), prevPicOrderCntLsb, prevPicOrderCntMsb, sps->getMaxPicOrderCntLsb() ); 
-    }
-    picOrderCntVal = picOrderCntMsb + slice->getSlicePicOrderCntLsb(); 
-  }  
+      Int prevPicOrderCntMsb = m_prevPicOrderCnt - prevPicOrderCntLsb;
+      picOrderCntMsb = xGetCurrMsb( slice->getSlicePicOrderCntLsb(), prevPicOrderCntLsb, prevPicOrderCntMsb, sps->getMaxPicOrderCntLsb() );
+    }
+    picOrderCntVal = picOrderCntMsb + slice->getSlicePicOrderCntLsb();
+  }
   return picOrderCntVal;
 }
@@ -1619,19 +1620,19 @@
     if ( m_lastPresentPocResetIdc[ m_apcSlicePilot->getLayerId() ] != MIN_INT )
     {
-      // - If the previous picture picA that has poc_reset_period_id present in the slice segment header is present in the same layer 
-      //   of the bitstream as the current picture, the value of poc_reset_period_id is inferred to be equal to the value of the 
+      // - If the previous picture picA that has poc_reset_period_id present in the slice segment header is present in the same layer
+      //   of the bitstream as the current picture, the value of poc_reset_period_id is inferred to be equal to the value of the
       //   poc_reset_period_id of picA.
 
-      m_apcSlicePilot->setPocResetPeriodId( m_lastPresentPocResetIdc[ m_apcSlicePilot->getLayerId() ] ); 
+      m_apcSlicePilot->setPocResetPeriodId( m_lastPresentPocResetIdc[ m_apcSlicePilot->getLayerId() ] );
     }
     else
     {
       //- Otherwise, the value of poc_reset_period_id is inferred to be equal to 0.
-      m_apcSlicePilot->setPocResetPeriodId( 0 ); 
+      m_apcSlicePilot->setPocResetPeriodId( 0 );
     }
   }
   else
   {
-    m_lastPresentPocResetIdc[ m_apcSlicePilot->getLayerId() ] = m_apcSlicePilot->getPocResetPeriodId();  
+    m_lastPresentPocResetIdc[ m_apcSlicePilot->getLayerId() ] = m_apcSlicePilot->getPocResetPeriodId();
   }
 }
@@ -1639,5 +1640,5 @@
 
 Void TDecTop::decodePocAndRps( )
-{ 
+{
   assert( m_uiSliceIdx == 0 );
   Int nuhLayerId = m_pcPic->getLayerId();
@@ -1646,12 +1647,12 @@
     // 8.1.3 Decoding process for a coded picture with nuh_layer_id equal to 0
 
-    // Variables and functions relating to picture order count are derived as 
-    // specified in clause 8.3.1. This needs to be invoked only for the first slice 
+    // Variables and functions relating to picture order count are derived as
+    // specified in clause 8.3.1. This needs to be invoked only for the first slice
     // segment of a picture.
     x831DecProcForPicOrderCount( );
 
-    // The decoding process for RPS in clause 8.3.2 is invoked, wherein reference 
-    // pictures may be marked as "unused for reference" or "used for long-term 
-    // reference". This needs to be invoked only for the first slice segment of a 
+    // The decoding process for RPS in clause 8.3.2 is invoked, wherein reference
+    // pictures may be marked as "unused for reference" or "used for long-term
+    // reference". This needs to be invoked only for the first slice segment of a
     // picture.
     x832DecProcForRefPicSet    (  false );
@@ -1666,12 +1667,12 @@
       // --> Clause 8.1.3 is invoked with replacments of 8.3.1, 8.3.2, and 8.3.3 by F.8.3.1, 8.3.2, and 8.3.3
 
-      // Variables and functions relating to picture order count are derived as 
-      // specified in clause 8.3.1. This needs to be invoked only for the first slice 
+      // Variables and functions relating to picture order count are derived as
+      // specified in clause 8.3.1. This needs to be invoked only for the first slice
       // segment of a picture.
       xF831DecProcForPicOrderCount( );
 
-      // The decoding process for RPS in clause 8.3.2 is invoked, wherein reference 
-      // pictures may be marked as "unused for reference" or "used for long-term 
-      // reference". This needs to be invoked only for the first slice segment of a 
+      // The decoding process for RPS in clause 8.3.2 is invoked, wherein reference
+      // pictures may be marked as "unused for reference" or "used for long-term
+      // reference". This needs to be invoked only for the first slice segment of a
       // picture.
       xF832DecProcForRefPicSet( );
@@ -1682,13 +1683,13 @@
       // nuh_layer_id greater than 0
 
-      // Variables and functions relating to picture order count are derived in clause F.8.3.1. 
-      // This needs to be invoked only for the first slice segment of a picture. It is a requirement 
-      // of bitstream conformance that PicOrderCntVal of each picture in an access unit shall have the 
+      // Variables and functions relating to picture order count are derived in clause F.8.3.1.
+      // This needs to be invoked only for the first slice segment of a picture. It is a requirement
+      // of bitstream conformance that PicOrderCntVal of each picture in an access unit shall have the
       // same value during and at the end of decoding of the access unit
       xF831DecProcForPicOrderCount( );
 
-      // The decoding process for RPS in clause F.8.3.2 is invoked, wherein only reference pictures with 
-      // nuh_layer_id equal to that of CurrPic may be marked as "unused for reference" or "used for 
-      // long-term reference" and any picture with a different value of nuh_layer_id is not marked. 
+      // The decoding process for RPS in clause F.8.3.2 is invoked, wherein only reference pictures with
+      // nuh_layer_id equal to that of CurrPic may be marked as "unused for reference" or "used for
+      // long-term reference" and any picture with a different value of nuh_layer_id is not marked.
       // This needs to be invoked only for the first slice segment of a picture.
       xF832DecProcForRefPicSet( );
@@ -1697,10 +1698,10 @@
   else
   {
-    assert( false ); 
+    assert( false );
   }
 }
 
 Void TDecTop::genUnavailableRefPics( )
-{ 
+{
   assert( m_uiSliceIdx == 0 );
   Int nuhLayerId = m_pcPic->getLayerId();
@@ -1711,9 +1712,9 @@
     if ( m_pcPic->isBla() || ( m_pcPic->isCra() && m_pcPic->getNoRaslOutputFlag() ) )
     {
-      // When the current picture is a BLA picture or is a CRA picture 
-      // with NoRaslOutputFlag equal to 1, the decoding process for generating 
-      // unavailable reference pictures specified in clause 8.3.3 is invoked, 
+      // When the current picture is a BLA picture or is a CRA picture
+      // with NoRaslOutputFlag equal to 1, the decoding process for generating
+      // unavailable reference pictures specified in clause 8.3.3 is invoked,
       // which needs to be invoked only for the first slice segment of a picture.
-      x8331GenDecProcForGenUnavilRefPics();       
+      x8331GenDecProcForGenUnavilRefPics();
     }
   }
@@ -1729,14 +1730,14 @@
       if ( m_pcPic->isBla() || ( m_pcPic->isCra() && m_pcPic->getNoRaslOutputFlag() ) )
       {
-        // When the current picture is a BLA picture or is a CRA picture 
-        // with NoRaslOutputFlag equal to 1, the decoding process for generating 
-        // unavailable reference pictures specified in clause 8.3.3 is invoked, 
+        // When the current picture is a BLA picture or is a CRA picture
+        // with NoRaslOutputFlag equal to 1, the decoding process for generating
+        // unavailable reference pictures specified in clause 8.3.3 is invoked,
         // which needs to be invoked only for the first slice segment of a picture.
-        xF833DecProcForGenUnavRefPics(); 
+        xF833DecProcForGenUnavRefPics();
       }
 #if NH_MV_FIX_INIT_NUM_ACTIVE_REF_LAYER_PICS
-      TComDecodedRps* decRps = m_pcPic->getDecodedRps(); 
+      TComDecodedRps* decRps = m_pcPic->getDecodedRps();
       decRps->m_numActiveRefLayerPics0 = 0;
-      decRps->m_numActiveRefLayerPics1 = 0;      
+      decRps->m_numActiveRefLayerPics1 = 0;
 #endif
     }
@@ -1748,6 +1749,6 @@
       if ( !m_firstPicInLayerDecodedFlag[ nuhLayerId ] )
       {
-        // When FirstPicInLayerDecodedFlag[ nuh_layer_id ] is equal to 0, the decoding process for generating 
-        // unavailable reference pictures for pictures first in decoding order within a layer specified in 
+        // When FirstPicInLayerDecodedFlag[ nuh_layer_id ] is equal to 0, the decoding process for generating
+        // unavailable reference pictures for pictures first in decoding order within a layer specified in
         // clause F.8.1.7 is invoked, which needs to be invoked only for the first slice segment of a picture.
         xF817DecProcForGenUnavRefPicForPicsFrstInDecOrderInLay();
@@ -1756,9 +1757,9 @@
       if ( m_firstPicInLayerDecodedFlag[ nuhLayerId ] && ( m_pcPic->isIrap() && m_pcPic->getNoRaslOutputFlag() ) )
       {
-        // When FirstPicInLayerDecodedFlag[ nuh_layer_id ] is equal to 1 and the current picture is an IRAP 
-        // picture with NoRaslOutputFlag equal to 1, the decoding process for generating unavailable reference 
-        // pictures specified in clause F.8.3.3 is invoked, which needs to be invoked only for the first slice 
+        // When FirstPicInLayerDecodedFlag[ nuh_layer_id ] is equal to 1 and the current picture is an IRAP
+        // picture with NoRaslOutputFlag equal to 1, the decoding process for generating unavailable reference
+        // pictures specified in clause F.8.3.3 is invoked, which needs to be invoked only for the first slice
         // segment of a picture.
-        xF833DecProcForGenUnavRefPics(); 
+        xF833DecProcForGenUnavRefPics();
       }
 
@@ -1772,12 +1773,12 @@
   else
   {
-    assert( false ); 
-  }
-
-  xCheckUnavailableRefPics();      
+    assert( false );
+  }
+
+  xCheckUnavailableRefPics();
 }
 Void TDecTop::executeLoopFilters( )
 {
-  assert( m_pcPic != NULL ); 
+  assert( m_pcPic != NULL );
   if ( !m_pcPic->getHasGeneratedRefPics() && !m_pcPic->getIsGenerated() )
   {
@@ -1791,6 +1792,6 @@
   if( m_pcPic->isIrap() )
   {
-    m_prevIrapPoc           = m_pcPic->getPOC(); 
-    m_prevIrapDecodingOrder = m_pcPic->getDecodingOrder(); 
+    m_prevIrapPoc           = m_pcPic->getPOC();
+    m_prevIrapDecodingOrder = m_pcPic->getDecodingOrder();
   }
   if( m_pcPic->isStsa() )
@@ -1803,44 +1804,44 @@
 
 Void TDecTop::initFromActiveVps( const TComVPS* vps )
-{   
-  setViewId   ( vps->getViewId   ( getLayerId() )      );  
+{
+  setViewId   ( vps->getViewId   ( getLayerId() )      );
 #if NH_3D
-  setViewIndex( vps->getViewIndex( getLayerId() )      );  
-  setIsDepth  ( vps->getDepthId  ( getLayerId() ) == 1 );  
+  setViewIndex( vps->getViewIndex( getLayerId() )      );
+  setIsDepth  ( vps->getDepthId  ( getLayerId() ) == 1 );
 #endif
 
   if ( !vps->getVpsExtensionFlag() )
   {
-    m_decodingProcess = CLAUSE_8; 
+    m_decodingProcess = CLAUSE_8;
     m_isInOwnTargetDecLayerIdList = ( getLayerId() ==  0 );
   }
   else
-  {  
+  {
     if ( m_targetOlsIdx == -1 )
     {
-      // Corresponds to specification by "External Means". (Should be set equal to 0, when no external means available. ) 
-      m_targetOlsIdx = vps->getVpsNumLayerSetsMinus1(); 
-    }
-
-    Int targetDecLayerSetIdx = vps->olsIdxToLsIdx( m_targetOlsIdx ); 
+      // Corresponds to specification by "External Means". (Should be set equal to 0, when no external means available. )
+      m_targetOlsIdx = vps->getVpsNumLayerSetsMinus1();
+    }
+
+    Int targetDecLayerSetIdx = vps->olsIdxToLsIdx( m_targetOlsIdx );
 
     if ( targetDecLayerSetIdx <= vps->getVpsNumLayerSetsMinus1() && vps->getVpsBaseLayerInternalFlag() )
     {
-      m_smallestLayerId = 0; 
+      m_smallestLayerId = 0;
     }
     else if ( targetDecLayerSetIdx <= vps->getVpsNumLayerSetsMinus1() && !vps->getVpsBaseLayerInternalFlag() )
     {
-      m_smallestLayerId = 0; 
+      m_smallestLayerId = 0;
     }
     else if ( targetDecLayerSetIdx > vps->getVpsNumLayerSetsMinus1() && vps->getNumLayersInIdList( targetDecLayerSetIdx) == 1 )
     {
-      
-      // m_smallestLayerId = 0;       
-      // For now don't do change of layer id here. 
-      m_smallestLayerId = vps->getTargetDecLayerIdList( targetDecLayerSetIdx )[ 0 ];    
+
+      // m_smallestLayerId = 0;
+      // For now don't do change of layer id here.
+      m_smallestLayerId = vps->getTargetDecLayerIdList( targetDecLayerSetIdx )[ 0 ];
     }
     else
     {
-      m_smallestLayerId = vps->getTargetDecLayerIdList( targetDecLayerSetIdx )[ 0 ];    
+      m_smallestLayerId = vps->getTargetDecLayerIdList( targetDecLayerSetIdx )[ 0 ];
     }
 
